package com.izouma.awesomeadmin.web;

import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ProductComment;
import com.izouma.awesomeadmin.service.ProductCommentService;
import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * controller类
 */
@Controller
@RequestMapping("/productComment")
@RequiresAuthentication
public class ProductCommentController {

    @Autowired
    private ProductCommentService productCommentService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ProductComment record) {
        List<ProductComment> pp = productCommentService.getProductCommentList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getProductComment", method = RequestMethod.GET)
    @ResponseBody
    public Result getProductComment(@RequestParam(required = false, value = "id") String id) {
        ProductComment data = productCommentService.getProductCommentById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ProductComment record) {
        ProductComment data = productCommentService.getProductComment(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ProductComment record) {
        Map<String, Object> result = new HashMap<>();

        List<ProductComment> pp = productCommentService.getProductCommentByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ProductComment record) {
        boolean num = productCommentService.createProductComment(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateProductComment(ProductComment record) {
        boolean num = productCommentService.updateProductComment(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteProductComment(@RequestParam(required = true, value = "id") String id) {

        boolean num = productCommentService.deleteProductComment(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ProductComment record) throws Exception {

        List<ProductComment> productComments = productCommentService.getProductCommentList(record);


        String sheetName = "product_comment";
        String titleName = "商品评论数据表";
        String fileName = "商品评论表";
        int columnNumber = 14;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "商品", "订单", "用户", "店铺", "评论", "星级", "匿名", "类型"};
        String[][] dataList = new String[productComments.size()][14];

        for (int i = 0; i < productComments.size(); i++) {

            dataList[i][0] = String.valueOf(productComments.get(i).getId());
            dataList[i][1] = String.valueOf(productComments.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(productComments.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(productComments.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(productComments.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(productComments.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(productComments.get(i).getProductId());
            dataList[i][7] = String.valueOf(productComments.get(i).getOrderId());
            dataList[i][8] = String.valueOf(productComments.get(i).getUserId());
            dataList[i][9] = String.valueOf(productComments.get(i).getStoreId());
            dataList[i][10] = String.valueOf(productComments.get(i).getContext());
            dataList[i][11] = String.valueOf(productComments.get(i).getStarLevel());
            dataList[i][12] = String.valueOf(productComments.get(i).getAnonymous());
            dataList[i][13] = String.valueOf(productComments.get(i).getTypeFlag());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }

    /**
     * 获取评论数和星级
     *
     * @param record
     * @return
     */
    @RequestMapping(value = "/count", method = RequestMethod.GET)
    @ResponseBody
    public Result getCount(ProductComment record) {
        ProductComment data = productCommentService.getCount(record);
        return new Result(true, data);
    }
}

